package Utils;
use Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw( hello );

=head1 NAME

Utils.pm - Exemple de module

=head1 SYNOPSIS

use Utils;
hello("Noel");

=head1 DESCRIPTION

Il s agit d un simple exemple de module avec une seule fonction et 
deux blocs BEGIN et END.

=head2 Exports

=over

=item :DEFAULT hello

=back

=cut

BEGIN
{
  print "Debut\n";
}
END
{
  print "Fin\n";
}

=head1 FUNCTION hello

Imprime simplement hello

=cut

sub hello
{
  my ($prenom) = @_;
  print "Bonjour $prenom\n";
}
1;

