#!/usr/bin/perl

# reference sur une liste

@t = ( 1, 2, 4);
$reft = \@t;
print @t,"\n";
print @$reft,"\n";
print $t[2],"\n";
print $$reft[2],"\n";
print $reft->[2],"\n";
print ref($reft),"\n";
print "\n";

#reference sur un hash

%h = ( "Noel" => 1953, "Yoan" => 1981 );
$refh = \%h;
print $h{Noel}, "\n";
print $$refh{"Noel"}, "\n";
print $refh->{Noel}, "\n";
print ref($refh),"\n";
print "\n";

#reference anonyme

$r = \123;
print $r,"\n";
print $$r,"\n";
print ref($r),"\n";
print "\n";

#reference sur une fonction

sub aff { my ($x)= @_;print "Hello $x!\n";}
$reff = \&aff;
&$reff("Noel");
$reff->("Noel");
aff("Noel");
&aff("Noel");
print ref($reff),"\n";
print "\n";

#structures complexes

print "\n";
$r = [ [1,2], 'a', ['c','d'],{'un'=>[3,4,5],'deux'=>6},'b'];
use Data::Dumper;
print Dumper($r);
print "\n";

# reference sur un fichier

open( FILE, ">essai" ) || dir("$!");
$reff = \*FILE;
print $reff, "\n";
print $reff "OK\n";
sub naff{ my ($x)= @_;print $reff "Hello!\n";}
naff $reff;
close $reff;
print ref($reff),"\n";
system( "cat essai");
