#!/usr/bin/perl

@stack = ();

while( <> ) {
  chop;
  /^\+$/ && do { $v = pop(@stack) + pop(@stack); printf "> %f\n", $v; push @stack,$v; next };
  /^\-$/ && do { $v = -pop(@stack) + pop(@stack); printf "> %f\n", $v; push @stack,$v; next };
  /^\*$/ && do { $v = pop(@stack) * pop(@stack); printf "> %f\n", $v; push @stack,$v; next };
  /^\/$/ && do { $v = 1/pop(@stack) * pop(@stack); printf "> %f\n", $v; push @stack,$v; next };
  /^\?$/ && do { print "> [ "; foreach $i (@stack) { print $i,", ";} print " ]\n"; next };
  /^\.$/ && do { printf "> %f\n", pop(@stack); next };
  /^q$/ && exit;
  /^-?\d*\.?\d*$/ && do { push @stack, $_; next };
  print "error!\n";
}
