#!/usr/bin/perl
# read database
open(DATA, "data") || die "Could't open data file";
while(<DATA>){
   /^\*name:/ && do { split ; $name = $_[1] ; next };
   /^\*phone:/ && do { split ; $phone{$name} = $_[1] ; next };
};
close DATA;
# report the result
@name = sort keys(%phone);   # build sorted keys list
print $#name+1, " entries read:\n";
foreach $name (@name) {
   printf "%-18s, phone number: %4s\n" , $name , $phone{$name};
};

