#!/usr/bin/perl

use figure;
use cercle;
use dessin;

$d = dessin->new();
$fig1 = figure->new('red');
$d->add($fig1);
$fig2 = figure->new('green');
$d->add($fig2);
$fig3 = figure->new('yellow');
$d->add($fig3);
$fig4 = cercle->new('red', 3.);
$d->add($fig4);

print '$d->list(): ', $d->list(),"\n";
print '$fig1: ', $fig1, "\n";
print '$fig4: ', $fig4, "\n";
print '$fig1->color(): ', $fig1->color(),"\n";
$fig1->set_color('orange');
print '$fig1->color(): ', $fig1->color(),"\n";
print 'figure->number(): ', figure->number(),"\n";
print 'cercle->number(): ', cercle->number(), "\n";
print '$fig4->surface(): ', $fig4->surface(),"\n";

use Data::Dumper;
print "Dumper($fig4):\n", Dumper($fig4),"\n";

print "acces direct au hash fig4:\n";
foreach $i (keys %$fig4 ) {
   print "$i : $fig4->{$i}\n";
}
$fig4->{color}='violet';
print '$fig4->color(): ', $fig4->color(),"\n";
