#!/usr/bin/perl

use Socket;
my $port = 1234;
my $proto = getprotobyname('tcp');

open(SLOG, ">LogFile") or die "open log: $!";
select(SLOG);$|=1;

socket(Sock, PF_INET, SOCK_STREAM, $proto)
    or die "socket: $!";
setsockopt(Sock, SOL_SOCKET, SO_REUSEADDR, 1)
    or die "setsockopt: $!";
bind(Sock, sockaddr_in($port, INADDR_ANY))
    or die "bind: $!";
listen(Sock, SOMAXCONN);

$SIG{INT} = 'quit';

while(1){
  $cli = accept(NewSock, Sock);
  my($port, $addr) = sockaddr_in($cli);
  $client = gethostbyaddr($addr, AF_INET);
  while($in = <NewSock>) {
    chop $in;
    print SLOG "$client: $in\n";
  }
  print SLOG "$client: closed\n";
  close NewSock;
}

sub quit {
  close SLOG;
  exit;
}
